************************************************************************
*
*  File: ASSARNEQ
*
*  Asserts that two numerical arrays are equal (contain the same
*  elements but not necessarily in the same order).
*
*  Tags: NUNIT, assertion
*
*  Parameters:
*    NUASSP    - Assertion parameters.
*    #EXPECTED - The expected value.
*    #ACTUAL   - The actual value.
*
*  Returns:
*    -
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: ASSARNEQ.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER USING NUASSP
*
PARAMETER
01 #EXPECTED (N20,7/1:*) BY VALUE
01 #ACTUAL   (N20,7/1:*) BY VALUE
*
LOCAL USING NUCONST
*
LOCAL
01 #I (N8)
01 #MESSAGE-PART (A) DYNAMIC
01 #INDEX (N6)
01 #VALUE-FOUND (L)
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE ASSERT-ARRAY-N-EQUALS
************************************************************************
*
INCLUDE NUASSHD
*
IF *OCCURRENCE(#ACTUAL) NE *OCCURRENCE(#EXPECTED)
  COMPRESS NUASSP.MESSAGE 'Arrays have different length.' INTO NUASSP.MESSAGE 
  *ERROR-NR := ASSERTION-ERROR 
END-IF
*
FOR #I 1 *OCCURRENCE(#EXPECTED)
* TODO: count occurrences of multiple values
  FOR #INDEX 1 *OCCURRENCE(#ACTUAL) 
    IF #ACTUAL(#INDEX) EQ #EXPECTED(#I) 
      #VALUE-FOUND := TRUE 
    END-IF 
  END-FOR 
  IF NOT #VALUE-FOUND 
    COMPRESS 'Element <' #EXPECTED(#I) '> not found.' INTO #MESSAGE-PART LEAVING NO SPACE 
    COMPRESS NUASSP.MESSAGE #MESSAGE-PART INTO NUASSP.MESSAGE 
  END-IF 
END-FOR
*
IF NUASSP.MESSAGE NE ' '
  *ERROR-NR := ASSERTION-ERROR 
END-IF
*
END-SUBROUTINE
************************************************************************
*
END
