************************************************************************
*
*  File: ASSFLTEQ
*
*  Asserts that the given floating point numbers are equal (difference
*  is less than the given accuracy).
*
*  Tags: Assertion, NUNIT
*
*  Parameters:
*    NUASSP    - Assertion parameters.
*    #EXPECTED - The expected value.
*    #ACTUAL   - The acutal value.
*    #ACCURACY - The accuracy of the comparison (e.g. 0,01).
*
*  Returns:
*    -
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: ASSFLTEQ.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER USING NUASSP
*
PARAMETER
01 #EXPECTED   (N20,6) BY VALUE
01 #ACTUAL     (N20,6) BY VALUE
01 #ACCURACY-P (N1,7)  BY VALUE OPTIONAL
*
LOCAL USING NUCONST
*
LOCAL
01 #DIFFERENCE (N20,7)
01 #ACCURACY (N1,7)
01 #GIVEN-MESSAGE (A) DYNAMIC
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE ASSERT-FLOAT-EQUALS
************************************************************************
*
INCLUDE NUASSHD
*
IF NUASSP.MESSAGE NE ' '
  #GIVEN-MESSAGE := NUASSP.MESSAGE 
END-IF
*
IF #ACCURACY-P NOT SPECIFIED
  #ACCURACY := 0 
ELSE
  #ACCURACY := #ACCURACY-P 
END-IF
IF #ACCURACY < 0
  #ACCURACY := #ACCURACY * -1 
END-IF
*
#DIFFERENCE := #EXPECTED - #ACTUAL
IF #DIFFERENCE < 0
  #DIFFERENCE := #DIFFERENCE * -1 
END-IF
IF #DIFFERENCE LE #ACCURACY
  #DIFFERENCE := 0 
END-IF
*
IF #DIFFERENCE NE 0
  COMPRESS NUMERIC '<' #ACTUAL '> should be <' #EXPECTED '> (accuracy:' #ACCURACY ')' INTO NUASSP.MESSAGE LEAVING NO SPACE 
  COMPRESS #GIVEN-MESSAGE NUASSP.MESSAGE INTO NUASSP.MESSAGE 
  *ERROR-NR := ASSERTION-ERROR 
END-IF
*
END-SUBROUTINE
*
END

