************************************************************************
*
*  File: NUGETPRO
*
*  Returns all problems that occured during the TestSuite's run.
*
*  Tags: NUNIT
*
*  Parameters:
*    NUTSP - The results of the TestSuite.
*
*  Returns:
*    #PROBLEMS - All problems in an array.
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: NUGETPRO.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER USING NUTSP
PARAMETER
01 #PROBLEMS (A/1:*) DYNAMIC
*
LOCAL USING NUCONST
*
LOCAL
01 #TC (N8)
01 #T (N8)
*
01 #L (N8)
01 #LINE (A) DYNAMIC
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE GET-PROBLEMS
************************************************************************
*
#L := 0
FTC. FOR #TC 1 *OCCURRENCE(NUTSP.TESTCASES)
*
  IF NUTSP.TC-RESULT(#TC) EQ SUCCESS 
    ESCAPE TOP 
  END-IF 
*
  COMPRESS FULL 'TestCase ' NUTSP.TESTCASES(#TC) ': ' INTO #LINE LEAVING NO 
  IF NUTSP.FIXTURE(#TC) NE ' ' 
    COMPRESS #LINE NUTSP.FIXTURE(#TC) INTO #LINE 
  ELSE 
    COMPRESS #LINE NUTSP.TC-MESSAGE(#TC) INTO #LINE 
  END-IF 
  ADD 1 TO #L 
  RESIZE ARRAY #PROBLEMS TO (1:#L) 
  #PROBLEMS(#L) := #LINE 
*
  FT. FOR #T 1 *OCCURRENCE(NUTSP.TEST, 2) 
*
    IF NUTSP.TEST(#TC, #T) EQ ' ' OR 
        NUTSP.TEST-RESULT(#TC, #T) EQ SUCCESS 
      ESCAPE TOP 
    END-IF 
*
    COMPRESS '  ->' NUTSP.TEST(#TC, #T) INTO #LINE 
    IF NUTSP.TEST-RESULT(#TC, #T) EQ FAILURE 
      COMPRESS #LINE '(Failure):'  INTO #LINE 
    ELSE 
      COMPRESS #LINE '(Error):'  INTO #LINE 
    END-IF 
    COMPRESS #LINE NUTSP.TEST-MESSAGE(#TC, #T) INTO #LINE 
    ADD 1 TO #L 
    RESIZE ARRAY #PROBLEMS TO (1:#L) 
    #PROBLEMS(#L) := #LINE 
*
  END-FOR 
*
END-FOR
*
END-SUBROUTINE
*
END
