************************************************************************
*
*  File: NUGETTSS
*
*  Returns all available TestSuites for the given user.
*
*  Tags: NUNIT
*
*  Parameters:
*    #USERNAME - The username.
*
*  Returns:
*    #TESTSUITES - The available TestSuites.
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: NUGETTSS.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER
01 #USERNAME (A8) BY VALUE
01 #TESTSUITES (A/1:*) DYNAMIC
*
LOCAL
01 #LINES (A200/1:*)
01 #NUM-LINES (N8)
01 #LINE (A) DYNAMIC
01 #L (N8)
*
01 #SUITENAME-LENGTH (N3)
01 #SUITENAME (A) DYNAMIC
01 #TS (N3)
*
01 #MESSAGE (A) DYNAMIC
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE GET-TESTSUITES
************************************************************************
*
REDUCE ARRAY #TESTSUITES TO 0
PERFORM READ-TESTCASE-FILE #USERNAME #LINES(*) #MESSAGE
*
IF #MESSAGE NE ' '
  WRITE #MESSAGE (AL=79) 
END-IF
*
FOR #L 1 *OCCURRENCE(#LINES)
*
  #LINE := *TRIM(#LINES(#L)) 
  IF *LENGTH(#LINE) EQ 0 
    ESCAPE TOP 
  END-IF 
*
* comments start with #
  IF SUBSTRING(#LINE, 1, 1) EQ '#' 
    ESCAPE TOP 
  END-IF 
*
* TestSuites start with [
  IF SUBSTRING(#LINE, 1, 1) EQ '[' 
    #SUITENAME-LENGTH := *LENGTH(#LINE) - 2 
    #SUITENAME := SUBSTRING(#LINE, 2, #SUITENAME-LENGTH) 
    ADD 1 TO #TS 
    RESIZE ARRAY #TESTSUITES TO (1:#TS) 
    #TESTSUITES(#TS) := #SUITENAME 
  END-IF 
*
END-FOR
*
IF *OCCURRENCE(#TESTSUITES) EQ 0
  WRITE 'No TestSuites found for user' #USERNAME 
END-IF
*
END-SUBROUTINE
*
END
