************************************************************************
*
*  File: NUREADTC
*
*  Reads the user's TestCase file.
*
*  Tags: NUNIT
*
*  Parameters:
*    #USERNAME - The username.
*
*  Returns:
*    #LINES   - The lines of the user's TestCase file.
*    #MESSAGE - The error message (if any).
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: NUREADTC.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER
01 #USERNAME (A8) BY VALUE
01 #LINES (A200/1:*)
01 #MESSAGE (A) DYNAMIC
*
LOCAL USING NUCONST
*
LOCAL
01 #WORKFILE (A) DYNAMIC
01 #LINE (A200)
01 #L (N8)
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE READ-TESTCASE-FILE
************************************************************************
*
REDUCE ARRAY #LINES TO 0
#L := 0
*
EXAMINE #USERNAME TRANSLATE INTO LOWER CASE
COMPRESS PATH-HOME #USERNAME '/' FILE-TESTCASES INTO #WORKFILE LEAVING NO
DEFINE WORK FILE 28 #WORKFILE
*
READ WORK 28 #LINE
  ADD 1 TO #L 
  RESIZE ARRAY #LINES TO (1:#L) 
  #LINES(#L) := #LINE 
END-WORK
*
CLOSE WORK 28
*
ON ERROR
  IF *ERROR-NR EQ 1599 /* READ/WRITE to non-existent file 
    COMPRESS 'Workfile not found:' #WORKFILE INTO #MESSAGE 
    ESCAPE ROUTINE 
  END-IF 
END-ERROR
*
END-SUBROUTINE
*
END
