************************************************************************
*
*  File: NUSHOWST
*
*  Shows NUNIT's statistics (aka the red bar).
*
*  Tags: NUNIT
*
*  Parameters:
*    NUTSP - The TestSuite's results.
*
*  Returns:
*    -
*
*  About:
*    Library       - NUNIT
*    Erstellt      - 29.08.2009
*    Autor         - $Author: Stefan $
*    Revison       - $LastChangedRevision: 264 $
*    Letzter Autor - $LastChangedBy: Stefan $
*    Modifiziert   - $Date: 2009-08-31 12:44:42 +0200 (Mo, 31 Aug 2009) $
*    Id            - $Id: NUSHOWST.NSS 264 2009-08-31 10:44:42Z Stefan $
************************************************************************
*
DEFINE DATA
*
PARAMETER USING NUTSP
*
PARAMETER
01 #WAIT-FOR-INPUT (L) BY VALUE
*
LOCAL USING NUCRSTAP
LOCAL USING NUCONST
*
LOCAL
01 #FORMAT-RESULTS (C) INIT <(AD=D)>
*
01 #NUM-ROWS (N2) CONST <20>
01 #NUM-COLS (N2) CONST <79>
*
01 #TC(N4)
01 #ROW (N2)
01 #RESULTS (A79/1:20)
*
01 #DIVIDEND (N4)
01 #REMAINDER (N2,2)
*
01 #NEW-ROW (L)
*
01 #RESULT-SYMBOLS (A1/1:3)
01 #TESTCASE-RESULT (N1)
01 #TESTCASE-FAILED-OR-ERROR (L)
*
END-DEFINE
*
************************************************************************
DEFINE SUBROUTINE SHOW-STATISTICS
************************************************************************
*
#RESULT-SYMBOLS(SUCCESS) := '.'
#RESULT-SYMBOLS(FAILURE) := 'F'
#RESULT-SYMBOLS(ERROR)   := 'E'
*
PERFORM CREATE-STATISTICS NUTSP NUCRSTAP
*
RESET #RESULTS(*)
#NEW-ROW := TRUE
#TESTCASE-FAILED-OR-ERROR := FALSE
*
FOR #TC 1 *OCCURRENCE(NUTSP.TC-RESULT)
*
  IF NUTSP.TC-RESULT(#TC) EQ 0 
    ESCAPE BOTTOM 
  END-IF 
*
  IF #NEW-ROW 
*
    ADD 1 TO #ROW 
    #NEW-ROW := FALSE 
*
    #DIVIDEND := #ROW 
    DIVIDE #NUM-ROWS INTO #DIVIDEND REMAINDER #REMAINDER 
    IF #REMAINDER EQ 1 
      #ROW := 1 
      RESET #RESULTS(*) 
    END-IF 
*
  END-IF 
*
  #DIVIDEND := #TC 
  DIVIDE #NUM-COLS INTO #DIVIDEND REMAINDER #REMAINDER 
  IF #REMAINDER EQ 0 
    #NEW-ROW := TRUE 
  END-IF 
*
  #TESTCASE-RESULT := NUTSP.TC-RESULT(#TC) 
  IF #TESTCASE-RESULT EQ ERROR OR 
      #TESTCASE-RESULT EQ FAILURE 
    #TESTCASE-FAILED-OR-ERROR := TRUE 
  END-IF 
  COMPRESS #RESULTS(#ROW) #RESULT-SYMBOLS(#TESTCASE-RESULT) 
    INTO #RESULTS(#ROW) LEAVING NO 
*
END-FOR
*
IF #TESTCASE-FAILED-OR-ERROR
  MOVE (AD=I) TO #FORMAT-RESULTS 
END-IF
*
IF #WAIT-FOR-INPUT
  INPUT USING MAP 'NUSTAT' 
ELSE
  SET CONTROL 'N' 
  INPUT USING MAP 'NUSTAT' 
END-IF
*
END-SUBROUTINE
*
END
